diff --git a/src/nsterm.m b/src/nsterm.m
index 68ad646..d5952b8 100644
--- a/src/nsterm.m
+++ b/src/nsterm.m
@@ -1992,7 +1992,7 @@ so some key presses (TAB) are swallowed by the system.  */
           [[child parentWindow] removeChildWindow:child];
 #if defined (NS_IMPL_COCOA) && MAC_OS_X_VERSION_MAX_ALLOWED >= 101000
 #if MAC_OS_X_VERSION_MIN_REQUIRED < 101000
-          if ([child respondsToSelector:@selector(setAccessibilitySubrole:)]
+          if ([child respondsToSelector:@selector(setAccessibilitySubrole:)])
 #endif
               [child setAccessibilitySubrole:NSAccessibilityStandardWindowSubrole];
 #endif
@@ -2006,7 +2006,7 @@ so some key presses (TAB) are swallowed by the system.  */
                          ordered: NSWindowAbove];
 #if defined (NS_IMPL_COCOA) && MAC_OS_X_VERSION_MAX_ALLOWED >= 101000
 #if MAC_OS_X_VERSION_MIN_REQUIRED < 101000
-          if ([child respondsToSelector:@selector(setAccessibilitySubrole:)]
+          if ([child respondsToSelector:@selector(setAccessibilitySubrole:)])
 #endif
               [child setAccessibilitySubrole:NSAccessibilityFloatingWindowSubrole];
 #endif
@@ -3178,8 +3178,28 @@ Note that CURSOR_WIDTH is meaningful only for (h)bar cursors.
 
   if ((phys_cursor_glyph = get_phys_cursor_glyph (w)) == NULL)
     {
-      if (glyph_row->exact_window_width_line_p
-          && w->phys_cursor.hpos >= glyph_row->used[TEXT_AREA])
+
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
+      /* This modification enables placement of the cursor-in-fringe bitmap when
+      the window-width is slightly less than `glyph_row->exact_window_width_line_p`.
+      This modification also prevents drawing the real cursor on the fringe (instead
+      of using the cursor-in-fringe bitmap) in the above-mentioned circumstance.
+      See the following related patches:
+      -  July 19, 2016:  bf5ddded70c11edaf3514b25da27fc71cfb8e965
+      -  May 21, 2016:  e5015c5d9632a0bf685c093249ae4a7d3e825b13
+      See the following bug reports:  #16856 and #29233. */
+      int frame_char_width = FRAME_COLUMN_WIDTH (f);
+      int text_area_width = window_box_width (w, TEXT_AREA);
+      bool cursor_in_fringe_p = w->phys_cursor.x + frame_char_width >= text_area_width;
+      if ((glyph_row->exact_window_width_line_p
+            && w->phys_cursor.hpos >= glyph_row->used[TEXT_AREA])
+          || cursor_in_fringe_p)
+
+/* *************************************************************************** */
+
         {
           glyph_row->cursor_in_fringe_p = 1;
           draw_fringe_bitmap (w, glyph_row, 0);
@@ -3215,23 +3235,107 @@ Note that CURSOR_WIDTH is meaningful only for (h)bar cursors.
       h = cursor_height;
     }
 
-  r.origin.x = fx, r.origin.y = fy;
-  r.size.height = h;
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
+  r.origin.x = (w->mc.fx > 0)
+               ? w->mc.fx
+               : fx;
+  r.origin.y = (w->mc.fy > 0)
+               ? w->mc.fy
+               : fy;
+  r.size.height = (w->mc.h > 0)
+                  ? w->mc.h
+                  : h;
   r.size.width = w->phys_cursor_width;
 
+/* *************************************************************************** */
+
+
   /* Prevent the cursor from being drawn outside the text area.  */
   if (ns_clip_to_row (w, glyph_row, TEXT_AREA, NO))
     {
       face = FACE_FROM_ID_OR_NULL (f, phys_cursor_glyph->face_id);
-      if (face && NS_FACE_BACKGROUND (face)
-          == ns_index_color (FRAME_CURSOR_COLOR (f), f))
+
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
+/* EXAMPLE OF HOW TO LOOK-UP A COLOR:
+  enum face_id face_id = lookup_named_face (w, f, intern ("+-vertical-bar-face"), true);
+  struct face *face = FACE_FROM_ID (f, face_id);
+  NSColor *color = ns_lookup_indexed_color (NS_FACE_FOREGROUND (face), f);
+*/
+
+  if (w->mc.glyph_flavor == MC_GLYPH
+      || w->mc.glyph_flavor == MC_GLYPHLESS
+      || w->mc.glyph_flavor == MC_GLYPH_TAB)
+    {
+      [[NSColor colorWithCalibratedRed: w->mc.red green: w->mc.green blue: w->mc.blue alpha: 1.0] set];
+      Lisp_Object buf = w->contents;
+      CHECK_BUFFER (buf);
+      struct buffer *b = XBUFFER (buf);
+      bool region_active_p = (!NILP (Vtransient_mark_mode)
+                              && !NILP (BVAR (b, mark_active)));
+      ptrdiff_t region_beginning = (region_active_p) ? XFIXNUM (Fregion_beginning ()) : -1;
+      ptrdiff_t region_end = (region_active_p) ? XFIXNUM (Fregion_end ()) : -1;
+      bool region_in_bounds_p = (region_active_p
+                                 && w->mc.posint >= region_beginning
+                                 && w->mc.posint < region_end);
+      if (region_active_p
+          && region_in_bounds_p
+          && active_p)
         {
-          [ns_lookup_indexed_color (NS_FACE_FOREGROUND (face), f) set];
-          hollow_color = FRAME_CURSOR_COLOR (f);
+          enum face_id hollow_active_region_face_id = lookup_named_face (w, f, intern ("+-real-fake-cursor-region-face"), true);
+          struct face *hollow_active_region_face = FACE_FROM_ID (f, hollow_active_region_face_id);
+          NSColor *hollow_active_region_color = ns_lookup_indexed_color (NS_FACE_BACKGROUND (hollow_active_region_face), f);
+          hollow_color = hollow_active_region_color;
         }
+        else if (region_active_p
+                 && !region_in_bounds_p
+                 && active_p)
+          {
+            enum face_id hollow_active_region_out_face_id = lookup_named_face (w, f, intern ("+-real-fake-cursor-region-face"), true);
+            struct face *hollow_active_region_out_face = FACE_FROM_ID (f, hollow_active_region_out_face_id);
+            NSColor *hollow_active_region_out_color = ns_lookup_indexed_color (NS_FACE_FOREGROUND (hollow_active_region_out_face), f);
+            hollow_color = hollow_active_region_out_color;
+          }
+          else if (!region_active_p && active_p)
+            {
+              enum face_id hollow_active_face_id = lookup_named_face (w, f, intern ("+-real-fake-cursor-face"), true);
+              struct face *hollow_active_face = FACE_FROM_ID (f, hollow_active_face_id);
+              NSColor *hollow_active_color = ns_lookup_indexed_color (NS_FACE_BACKGROUND (hollow_active_face), f);
+              hollow_color = hollow_active_color;
+            }
+            /* The region is _not_ visible in the inactive window because the overlay window property is used. */
+            else if (!active_p)
+              {
+                enum face_id hollow_inactive_face_id = lookup_named_face (w, f, intern ("+-real-fake-cursor-inactive-face"), true);
+                struct face *hollow_inactive_face = FACE_FROM_ID (f, hollow_inactive_face_id);
+                NSColor *hollow_inactive_color = ns_lookup_indexed_color (NS_FACE_BACKGROUND (hollow_inactive_face), f);
+                hollow_color = hollow_inactive_color;
+              }
+              else if (face && NS_FACE_BACKGROUND (face) == ns_index_color (FRAME_CURSOR_COLOR (f), f))
+                hollow_color = FRAME_CURSOR_COLOR (f);
+                else
+                  {
+                    struct face *default_bg_face = FACE_FROM_ID (f, DEFAULT_FACE_ID);
+                    [ns_lookup_indexed_color (NS_FACE_BACKGROUND (default_bg_face), f) set];
+                    hollow_color = FRAME_CURSOR_COLOR (f);
+                  }
+    }
+    else if (face && NS_FACE_BACKGROUND (face) == ns_index_color (FRAME_CURSOR_COLOR (f), f))
+      {
+        [ns_lookup_indexed_color (NS_FACE_FOREGROUND (face), f) set];
+        hollow_color = FRAME_CURSOR_COLOR (f);
+      }
       else
         [FRAME_CURSOR_COLOR (f) set];
 
+/* *************************************************************************** */
+
+
 #ifdef NS_IMPL_COCOA
       /* TODO: This makes drawing of cursor plus that of phys_cursor_glyph
          atomic.  Cleaner ways of doing this should be investigated.
@@ -3260,20 +3364,45 @@ Note that CURSOR_WIDTH is meaningful only for (h)bar cursors.
           break;
         case BAR_CURSOR:
           s = r;
-          /* If the character under cursor is R2L, draw the bar cursor
-             on the right of its glyph, rather than on the left.  */
-          cursor_glyph = get_phys_cursor_glyph (w);
-          if ((cursor_glyph->resolved_level & 1) != 0)
-            s.origin.x += cursor_glyph->pixel_width - s.size.width;
+
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
+
+    /* @lawlist is focusing the initial development of feature requests #17684
+    and #22873 on L2R languages. */
+    if (w->mc.glyph_flavor != MC_GLYPH
+        && w->mc.glyph_flavor != MC_GLYPHLESS
+        && w->mc.glyph_flavor != MC_GLYPH_TAB)
+      {
+      /* If the character under cursor is R2L, draw the bar cursor
+         on the right of its glyph, rather than on the left.  */
+      cursor_glyph = get_phys_cursor_glyph (w);
+      if ((cursor_glyph->resolved_level & 1) != 0)
+        s.origin.x += cursor_glyph->pixel_width - s.size.width;
+      }
+
+/* *************************************************************************** */
+
 
           NSRectFill (s);
           break;
         }
       ns_reset_clipping (f);
 
-      /* draw the character under the cursor */
-      if (cursor_type != NO_CURSOR)
-        draw_phys_cursor_glyph (w, glyph_row, DRAW_CURSOR);
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
+  /* draw the character under the cursor */
+  if (cursor_type != NO_CURSOR
+      && w->mc.glyph_flavor != MC_GLYPHLESS
+      && w->mc.glyph_flavor != MC_GLYPH_TAB)
+    draw_phys_cursor_glyph (w, glyph_row, DRAW_CURSOR);
+
+/* *************************************************************************** */
+
 
 #ifdef NS_IMPL_COCOA
       NSEnableScreenUpdates ();
diff --git a/src/w32term.c b/src/w32term.c
index 8d189ae..7dd7756 100644
--- a/src/w32term.c
+++ b/src/w32term.c
@@ -973,6 +973,20 @@ static void w32_draw_box_rect (struct glyph_string *, int, int, int, int,
 static void
 x_set_cursor_gc (struct glyph_string *s)
 {
+
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
+  if (s->w->mc.cursor_gc_default)
+    {
+      s->gc = s->f->output_data.w32->cursor_gc;
+      return;
+    }
+
+/* *************************************************************************** */
+
+
   if (s->font == FRAME_FONT (s->f)
       && s->face->background == FRAME_BACKGROUND_PIXEL (s->f)
       && s->face->foreground == FRAME_FOREGROUND_PIXEL (s->f)
@@ -5690,6 +5704,26 @@ x_draw_hollow_cursor (struct window *w, struct glyph_row *row)
 
   /* Compute frame-relative coordinates for phys cursor.  */
   get_phys_cursor_geometry (w, row, cursor_glyph, &left, &top, &h);
+
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
+/* LEGEND:
+
+-  top y == WINDOW_TO_FRAME_PIXEL_Y (w, row->y)
+
+-  bottom y == WINDOW_TO_FRAME_PIXEL_Y (w, row->y) - row->height
+
+-  h of HOLLOW_BOX_CURSOR == row->height
+   [This avoids a visible gap above/below.] */
+
+  if (w->mc.h > 0)
+    h = row->height;
+
+/* *************************************************************************** */
+
+
   rect.left = left;
   /* When on R2L character, show cursor at the right edge of the
      glyph, unless the cursor box is as wide as the glyph or wider
@@ -5753,7 +5787,17 @@ x_draw_bar_cursor (struct window *w, struct glyph_row *row,
 	 invisible.  Use the glyph's foreground color instead in this
 	 case, on the assumption that the glyph's colors are chosen so
 	 that the glyph is legible.  */
-      if (face->background == cursor_color)
+
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
+      if (face->background == cursor_color
+          && !w->mc.cursor_gc_invisible_okay)
+
+/* *************************************************************************** */
+
+
 	cursor_color = face->foreground;
 
       x = WINDOW_TEXT_TO_FRAME_PIXEL_X (w, w->phys_cursor.x);
@@ -5774,6 +5818,17 @@ x_draw_bar_cursor (struct window *w, struct glyph_row *row,
 	  if ((cursor_glyph->resolved_level & 1) != 0)
 	    x += cursor_glyph->pixel_width - width;
 
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
+    /* Align all fake BAR_CURSOR of the VERTICAL_RULER with `opoint_x'. */
+    if (w->mc.fx > 0)
+      x = w->mc.fx;
+
+/* *************************************************************************** */
+
+
 	  w32_fill_area (f, hdc, cursor_color, x,
 			 WINDOW_TO_FRAME_PIXEL_Y (w, w->phys_cursor.y),
 			 width, row->height);
@@ -5895,31 +5950,159 @@ w32_draw_window_cursor (struct window *w, struct glyph_row *glyph_row,
 	  return;
 	}
 
-      switch (cursor_type)
-	{
-	case HOLLOW_BOX_CURSOR:
-	  x_draw_hollow_cursor (w, glyph_row);
-	  break;
 
-	case FILLED_BOX_CURSOR:
-	  draw_phys_cursor_glyph (w, glyph_row, DRAW_CURSOR);
-	  break;
+/* *************************************************************************** */
+/* begin MULTIPLE CURSORS */
 
-	case BAR_CURSOR:
-	  x_draw_bar_cursor (w, glyph_row, cursor_width, BAR_CURSOR);
-	  break;
+  struct frame *f = XFRAME (WINDOW_FRAME (w));
+  COLORREF original_cursor_pixel = f->output_data.w32->cursor_pixel;
+  /* xterm.c/xterm.h use GC; whereas, w32term.c/w32term.h use XGCValues * */
+  XGCValues *original_cursor_gc = f->output_data.w32->cursor_gc;
+  double base = 255.0;
+  double term_red = base * w->mc.red;
+  double term_green = base * w->mc.green;
+  double term_blue = base * w->mc.blue;
+  int int_red = XFIXNUM (Ftruncate (make_float (term_red), Qnil));
+  int int_green = XFIXNUM (Ftruncate (make_float (term_green), Qnil));;
+  int int_blue = XFIXNUM (Ftruncate (make_float (term_blue), Qnil));;
+  COLORREF color_pixel = PALETTERGB (int_red, int_green, int_blue);
+  switch (cursor_type)
+  {
+    case HOLLOW_BOX_CURSOR:
+    {
+      if (w->mc.red >= 0 && w->mc.blue >= 0 && w->mc.green >= 0)
+        {
+          XGCValues gc_values;
+          unsigned long mask = GCFont | GCForeground | GCBackground;
+          gc_values.font = FRAME_FONT (f);
+          struct face *default_face = FACE_FROM_ID (f, DEFAULT_FACE_ID);
+          Lisp_Object buf = w->contents;
+          CHECK_BUFFER (buf);
+          struct buffer *b = XBUFFER (buf);
+          bool region_active_p = (!NILP (Vtransient_mark_mode)
+                                  && !NILP (BVAR (b, mark_active)));
+          ptrdiff_t region_beginning = (region_active_p) ? XFIXNUM (Fregion_beginning ()) : -1;
+          ptrdiff_t region_end = (region_active_p) ? XFIXNUM (Fregion_end ()) : -1;
+          bool region_in_bounds_p = (region_active_p
+                                     && w->mc.posint >= region_beginning
+                                     && w->mc.posint < region_end);
+          /* Temporarily hijack `f->output_data.w32->cursor_gc' by borrowing the
+          functionality of `x_make_gc' in w32fns.c.  */
+          if (region_active_p
+              && region_in_bounds_p
+              && active_p)
+            {
+              enum face_id hollow_active_region_face_id = lookup_named_face (w, f, intern ("+-real-fake-cursor-region-face"), true);
+              struct face *hollow_active_region_face = FACE_FROM_ID (f, hollow_active_region_face_id);
+              gc_values.foreground = default_face->foreground;
+              gc_values.background = hollow_active_region_face->background;
+            }
+            else if (region_active_p
+                     && !region_in_bounds_p
+                     && active_p)
+              {
+                enum face_id hollow_active_region_out_face_id = lookup_named_face (w, f, intern ("+-real-fake-cursor-region-face"), true);
+                struct face *hollow_active_region_out_face = FACE_FROM_ID (f, hollow_active_region_out_face_id);
+                gc_values.foreground = default_face->foreground;
+                gc_values.background = hollow_active_region_out_face->foreground;
+              }
+              else if (!region_active_p && active_p)
+                {
+                  enum face_id hollow_active_face_id = lookup_named_face (w, f, intern ("+-real-fake-cursor-face"), true);
+                  struct face *hollow_active_face = FACE_FROM_ID (f, hollow_active_face_id);
+                  gc_values.foreground = default_face->foreground;
+                  gc_values.background = hollow_active_face->background;
+                }
+                /* The region is _not_ visible in the inactive window because the overlay window property is used. */
+                else if (!active_p)
+                  {
+                    enum face_id hollow_inactive_face_id = lookup_named_face (w, f, intern ("+-real-fake-cursor-inactive-face"), true);
+                    struct face *hollow_inactive_face = FACE_FROM_ID (f, hollow_inactive_face_id);
+                    gc_values.foreground = default_face->foreground;
+                    gc_values.background = hollow_inactive_face->background;
+                  }
+          f->output_data.w32->cursor_gc = XCreateGC (NULL, FRAME_W32_WINDOW (f), mask, &gc_values);
+          block_input ();
+          /* Force `x_set_cursor_gc' to use `s->f->output_data.w32->cursor_gc'.  */
+          w->mc.cursor_gc_default = true;
+          draw_phys_cursor_glyph (w, glyph_row, DRAW_CURSOR);
+          w->mc.cursor_gc_default = false;
+          f->output_data.w32->cursor_gc = original_cursor_gc;
+          unblock_input ();
+          /* Temporarily hijack `f->output_data.w32->cursor_pixel'.  */
+          f->output_data.w32->cursor_pixel = color_pixel;
+          x_draw_hollow_cursor (w, glyph_row);
+          f->output_data.w32->cursor_pixel = original_cursor_pixel;
+        }
+        else
+          x_draw_hollow_cursor (w, glyph_row);
+      break;
+    }
+    case FILLED_BOX_CURSOR:
+    {
+      if (w->mc.red >= 0 && w->mc.blue >= 0 && w->mc.green >= 0)
+        {
+          /* Temporarily hijack `f->output_data.w32->cursor_gc' by borrowing the
+          functionality of `x_make_gc' in w32fns.c.  */
+          block_input ();
+          XGCValues gc_values;
+          unsigned long mask = GCFont | GCForeground | GCBackground;
+          gc_values.font = FRAME_FONT (f);
+          gc_values.foreground = FRAME_BACKGROUND_PIXEL (f);
+          gc_values.background = color_pixel;
+          f->output_data.w32->cursor_gc = XCreateGC (NULL, FRAME_W32_WINDOW (f), mask, &gc_values);
+          /* Force `x_set_cursor_gc' to use `s->f->output_data.w32->cursor_gc'.  */
+          w->mc.cursor_gc_default = true;
+          draw_phys_cursor_glyph (w, glyph_row, DRAW_CURSOR);
+          w->mc.cursor_gc_default = false;
+          f->output_data.w32->cursor_gc = original_cursor_gc;
+          unblock_input ();
+        }
+        else
+          draw_phys_cursor_glyph (w, glyph_row, DRAW_CURSOR);
+      break;
+    }
+    case BAR_CURSOR:
+    {
+      if (w->mc.red >= 0 && w->mc.blue >= 0 && w->mc.green >= 0)
+        {
+          /* Temporarily hijack `f->output_data.w32->cursor_pixel'.  */
+          f->output_data.w32->cursor_pixel = color_pixel;
+          w->mc.cursor_gc_invisible_okay = true;
+          x_draw_bar_cursor (w, glyph_row, cursor_width, BAR_CURSOR);
+          w->mc.cursor_gc_invisible_okay = false;
+          f->output_data.w32->cursor_pixel = original_cursor_pixel;
+        }
+        else
+          x_draw_bar_cursor (w, glyph_row, cursor_width, BAR_CURSOR);
+      break;
+    }
+    case HBAR_CURSOR:
+    {
+      if (w->mc.red >= 0 && w->mc.blue >= 0 && w->mc.green >= 0)
+        {
+          /* Temporarily hijack `f->output_data.w32->cursor_pixel'.  */
+          f->output_data.w32->cursor_pixel = color_pixel;
+          w->mc.cursor_gc_invisible_okay = true;
+          x_draw_bar_cursor (w, glyph_row, cursor_width, HBAR_CURSOR);
+          w->mc.cursor_gc_invisible_okay = false;
+          f->output_data.w32->cursor_pixel = original_cursor_pixel;
+        }
+        else
+          x_draw_bar_cursor (w, glyph_row, cursor_width, HBAR_CURSOR);
+      break;
+    }
+    case NO_CURSOR:
+      w->phys_cursor_width = 0;
+      break;
+    default:
+      emacs_abort ();
+  }
 
-	case HBAR_CURSOR:
-	  x_draw_bar_cursor (w, glyph_row, cursor_width, HBAR_CURSOR);
-	  break;
+/* end MULTIPLE CURSORS */
+/* *************************************************************************** */
 
-	case NO_CURSOR:
-	  w->phys_cursor_width = 0;
-	  break;
 
-	default:
-	  emacs_abort ();
-	}
     }
 }
 
diff --git a/src/window.c b/src/window.c
index 6cdc52f..045899c 100644
--- a/src/window.c
+++ b/src/window.c
@@ -6846,6 +6846,29 @@ get_phys_cursor_glyph (struct window *w)
   struct glyph *glyph;
   int hpos = w->phys_cursor.hpos;
 
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
+/* This modification enables placement of the cursor-in-fringe bitmap when
+the window-width is slightly less than `glyph_row->exact_window_width_line_p`.
+This modification also prevents drawing the real cursor on the fringe (instead
+of using the cursor-in-fringe bitmap) in the above-mentioned circumstance.
+See the following related patches:
+-  July 19, 2016:  bf5ddded70c11edaf3514b25da27fc71cfb8e965
+-  May 21, 2016:  e5015c5d9632a0bf685c093249ae4a7d3e825b13
+See the following bug reports:  #16856 and #29233. */
+
+  struct frame *f = XFRAME (w->frame);
+  int frame_char_width = FRAME_COLUMN_WIDTH (f);
+  int text_area_width = window_box_width (w, TEXT_AREA);
+  bool cursor_in_fringe_p = w->phys_cursor.x + frame_char_width >= text_area_width;
+  if (cursor_in_fringe_p)
+    return NULL;
+
+/* *************************************************************************** */
+
+
   if (!(w->phys_cursor.vpos >= 0
 	&& w->phys_cursor.vpos < w->current_matrix->nrows))
     return NULL;
diff --git a/src/window.h b/src/window.h
index cc0b6b6..cabee27 100644
--- a/src/window.h
+++ b/src/window.h
@@ -76,6 +76,56 @@ one and the same, so its prev and next members are nil.
 
 A dead window has its contents field set to nil.  */
 
+
+/* *************************************************************************** */
+/* begin MULTIPLE CURSORS */
+
+/* Suffixes for the `mc` window pointer prefix. */
+struct multiple_cursors
+{
+  /* Values for previous and current `window-start' and `window-end'. */
+  EMACS_INT current_start, current_end, previous_start, previous_end, current_x, previous_x;
+
+  /* True means to force `x_set_cursor_gc' to use `s->f->output_data.w32->cursor_gc'
+  in w32term.c or `s->f->output_data.x->cursor_gc' in xterm.c. */
+  bool_bf cursor_gc_default : 1;
+
+  /* True means `x_set_cursor_gc' should permit the foreground and background
+  colors to be the same.  The default behavior disallows an invisible result. */
+  bool_bf cursor_gc_invisible_okay : 1;
+
+  /* True means `mc_draw_multiple_cursors' has not run yet drawn glyph fake cursors. */
+  bool_bf draw_multiple_cursors : 1;
+
+  /* True means `mc_erase_multiple_cursors' has not run yet erased glyph fake cursors. */
+  bool_bf erase_multiple_cursors : 1;
+
+  /* True means crosshairs have not yet been drawn. */
+  bool_bf draw_crosshairs : 1;
+
+  /* True means crosshairs have not yet been erased. */
+  bool_bf erase_crosshairs : 1;
+
+  /* The flavor of the glyph used by `draw_window_cursor'. */
+  int glyph_flavor;
+
+  /* L.S.L. colors. */
+  double red, green, blue;
+
+  /* The buffer position point of a fake cursor. */
+  int posint;
+
+  /* Pixel position (window relative) of horizontal/vertical rulers. */
+  int fx, fy, h;
+
+  /* Record FROM_WHERE when `redisplay_preserve_echo_area' is called. */
+  int redisplay_preserve_echo_area;
+};
+
+/* end MULTIPLE CURSORS */
+/* *************************************************************************** */
+
+
 struct cursor_pos
 {
   /* Pixel position.  These are always window relative.  */
@@ -181,6 +231,22 @@ struct window
     /* The help echo text for this window.  Qnil if there's none.  */
     Lisp_Object mode_line_help_echo;
 
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
+    /* The cache for multiple glyph cursors.  For an example of the structure of
+    the list, see the comments at the beginning of `mc_calc' in xdisp.c.  */
+    Lisp_Object multiple_cursors_cache;
+
+    /* The cache for multiple glyph/glyphless cursors that form crosshairs.  For an
+    example of the structure of the list, see the comments at the beginning of
+    `mc_crosshairs' in xdisp.c.  */
+    Lisp_Object crosshairs_cache;
+
+/* *************************************************************************** */
+
+
     /* No Lisp data may follow below this point without changing
        mark_object in alloc.c.  The member current_matrix must be the
        first non-Lisp member.  */
@@ -283,6 +349,16 @@ struct window
 
 #ifdef HAVE_WINDOW_SYSTEM
 
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
+    /* The prefix for window pointers relating to multiple cursors.  */
+    struct multiple_cursors mc;
+
+/* *************************************************************************** */
+
+
     /* Cursor type of last cursor drawn on the window.  */
     enum text_cursor_kinds phys_cursor_type;
 
@@ -421,6 +497,25 @@ XWINDOW (Lisp_Object a)
   return XUNTAG (a, Lisp_Vectorlike, struct window);
 }
 
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
+INLINE void
+wset_multiple_cursors_cache (struct window *w, Lisp_Object val)
+{
+  w->multiple_cursors_cache = val;
+}
+
+INLINE void
+wset_crosshairs_cache (struct window *w, Lisp_Object val)
+{
+  w->crosshairs_cache = val;
+}
+
+/* *************************************************************************** */
+
+
 /* Most code should use these functions to set Lisp fields in struct
    window.  */
 INLINE void
diff --git a/src/xdisp.c b/src/xdisp.c
index d61d421..9df78b1 100644
--- a/src/xdisp.c
+++ b/src/xdisp.c
@@ -830,7 +830,7 @@ static intmax_t message_log_check_duplicate (ptrdiff_t, ptrdiff_t);
 static void push_it (struct it *, struct text_pos *);
 static void iterate_out_of_display_property (struct it *);
 static void pop_it (struct it *);
-static void redisplay_internal (void);
+static void redisplay_internal (int);
 static void echo_area_display (bool);
 static void block_buffer_flips (void);
 static void unblock_buffer_flips (void);
